Attribute VB_Name = "MainModule"
'Copyright Stephen W McNamee 2003
'Freely re-distributable privided the above copyright is left intact
'
Option Explicit
Option Base 1

Public Const cAPP_NAME = "Falcon Switcher"
Public Const cINI_FILENAME = "FalconSwitcher.ini"
Public Const cREG_FILE_EXT = "registry"

Public Const cDEFAULT_EXE = "FalconSP.exe"
Public Const cDEFAULT_EXE_BMS = "F4-BMS.exe"

Public Const c_SAVE_PATH = "Campaign\SAVE"
Public Const c_PATCH_PATH = "Patches"
Public Const c_PIC_PATH = "Pictures"
Public Const c_ACMI_PATH = "acmibin"
Public Const c_CONFIG_PATH = "config"

Public Const c_DEFAULTKEYFILE = "keystrokes.key"
Public Const c_DEFAULTBAKKEYFILE = "keystrokes.def"

Public Const cMAX_INSTALLS = 100
Public Const cGRP_STATE = "State"
Public Const cGRP_INSTALLS = "Installs"
Public Const cGRP_PATHS = "Paths"
Public Const cGRP_KEYFILE = "CurrentKeyfile"
Public Const cGRP_CL_1 = "CommandLine1"
Public Const cGRP_CL_2 = "CommandLine2"
Public Const cGRP_CL_3 = "CommandLine3"
Public Const cGRP_CL_4 = "CommandLine4"
Public Const cGRP_CL_5 = "CommandLine5"
Public Const cGRP_CL_6 = "CommandLine6"
Public Const cGRP_CL_7 = "CommandLine7"
Public Const cGRP_CL_8 = "CommandLine8"
Public Const cGRP_CLCAP_1 = "CommandLineCaption1"
Public Const cGRP_CLCAP_2 = "CommandLineCaption2"
Public Const cGRP_CLCAP_3 = "CommandLineCaption3"
Public Const cGRP_CLCAP_4 = "CommandLineCaption4"
Public Const cGRP_CLCAP_5 = "CommandLineCaption5"
Public Const cGRP_CLCAP_6 = "CommandLineCaption6"
Public Const cGRP_CLCAP_7 = "CommandLineCaption7"
Public Const cGRP_CLCAP_8 = "CommandLineCaption8"

Public Const cFALCON_REG_PATH = "Software\Microprose\Falcon\4.0"
Public Const cF4PATCH_REG_PATH = "Software\F4Patch"
Public Const cFALCONPATH_REG = "baseDir"

Public Const cLAUNCHMODE_LAUNCH = 1
Public Const cLAUNCHMODE_EDIT = 2
Public Const cLAUNCHMODE_ADD = 3

Private Const CMD_COPYALL = "/ALL"
Private Const CMD_COPYLBK = "/LBK"
Private Const CMD_COPYPHNBK = "/PBK"
Private Const CMD_SHOW = "/SHOW"
Private Const CMD_LAUNCH = "/LAUNCH"
Private Const CMD_AUTO = "/AUTO"
Private Const CMD_NOCOPY = "/NOCOPY"
'Private Const CMD_ = "/"
'Private Const CMD_ = "/"
Private Const FULLPATHMACRO = "#"

Global gWindowLeft As Integer, gWindowTop As Integer
Global gIniFilePath As String, gFalconSourcePath As String
Global gInstalls(cMAX_INSTALLS) As String
Global gCopyAll As Boolean
Global gCopyLbk As Boolean
Global gCopyPbk As Boolean
Global gCopyNone As Boolean
Global gSlctAllTAC As Boolean
Global gSlctAllCam As Boolean
Global gInstall, gCommandLine
Global gAuto As Boolean
Global gDebug As Boolean
Global gCdToPath, gCdToDisk
Global gNoCopy As Boolean
'
'

Public Sub ReInitialise()

gFalconSourcePath = GetFalconInstallPath()

End Sub

Public Function GetDefaultExe(ByVal pFalconPath As String) As String

Dim mRet As String
Dim mExePath As String
Dim sp As New swmProcs

mRet = cDEFAULT_EXE

If NotBlank(pFalconPath) Then
    mExePath = pFalconPath & "\" & cDEFAULT_EXE_BMS
    If sp.CheckFileExists(mExePath) Then
        mRet = cDEFAULT_EXE_BMS
    End If
End If

GetDefaultExe = mRet

End Function

Public Sub Main()

Dim mr As New swmWinAPIReg
Dim mf As New swmForms
Dim t

SetAppName cAPP_NAME
gCopyAll = False
gCopyLbk = False
gCopyPbk = False
gCopyNone = False
gSlctAllTAC = False
gSlctAllCam = False
gInstall = 0
gCommandLine = 0
gAuto = False
gDebug = False
gNoCopy = False

gFalconSourcePath = GetFalconInstallPath()
If IsBlank(gFalconSourcePath) Then
    Msg "Falcon 4 does not appear to be installed on this PC", cAPP_NAME & " will now terminate"
    Exit Sub
End If

getSettings

GetInstalls

If NotBlank(Command) Then
    If InStr(1, UCase(Command), "/DEBUG") <> 0 Then
        gDebug = True
    End If
    
    If InStr(1, UCase(Command), CMD_SHOW) <> 0 Then
        showInstall
        Exit Sub
    End If
    
    If InStr(1, UCase(Command), CMD_LAUNCH) <> 0 Then
        LaunchCurrentInstall
        Exit Sub
    End If

    parseCommandLine

    If InStr(1, UCase(Command), "/TEST") <> 0 Then
        test
        Exit Sub
    End If
End If

If NotBlank(gInstall) Then
        Load MainForm
        MainForm.AutoSwitch gInstall
        Exit Sub
End If

If Not checkCurrentInstall() Then
    Exit Sub
End If
GetInstalls

Load MainForm
MainForm.Caption = cAPP_NAME & "   Version " & App.Major & "." & App.Minor & "   Rev " & App.Revision
MainForm.Left = gWindowLeft
MainForm.Top = gWindowTop
MainForm.Show

End Sub

'Private Const CMD_COPYALL = "/ALL"
'Private Const CMD_COPYLBK = "/LBK"
'Private Const CMD_COPYPHNBK = "/PBK"
Private Sub parseCommandLine()

Dim mLine, mTail, mClNum
Dim i As Integer
Dim mPos As Integer
Dim mLen As Integer

mLine = UCase(Trim(Command))
mLen = Len(mLine)

If InStr(1, mLine, CMD_COPYALL) <> 0 Then
    gCopyAll = True
End If
If InStr(1, mLine, CMD_COPYLBK) <> 0 Then
    gCopyLbk = True
End If
If InStr(1, mLine, CMD_COPYPHNBK) <> 0 Then
    gCopyPbk = True
End If
If InStr(1, mLine, CMD_NOCOPY) <> 0 Then
    gNoCopy = True
End If

For i = cMAX_INSTALLS To 1 Step -1
    If InStr(1, mLine, "/" & i) <> 0 Then
        gInstall = i
        Exit For
    End If
Next i

mPos = InStr(1, mLine, CMD_AUTO)
If mPos <> 0 Then
    mTail = Right(mLine, mLen - (mPos + Len(CMD_AUTO)) + 1)
    If Len(mTail) < 2 Then
        gCommandLine = 1
    ElseIf Left(mTail, 1) = "=" Then
        mClNum = Mid(mTail, 2, 1)
        If IsNumeric(mClNum) Then
            If Val(mClNum) < 1 Or Val(mClNum) > 5 Then
                Err.Raise 9999, "", "Command Line number must be between 1 and 5"
            Else
                gCommandLine = Val(mClNum)
            End If
        End If
    Else
        gCommandLine = 1
    End If
    gAuto = True
End If

End Sub

Public Function GetSettingNum(ByVal pSection, ByVal pKey) As Integer

Dim t
Dim mRet As Integer

t = GetSetting(pSection, pKey)
If IsBlank(t) Then
    mRet = 0
Else
    mRet = Val(t)
End If

GetSettingNum = mRet

End Function

Public Function GetSettingString(ByVal pSection, ByVal pKey) As String

Dim t
Dim mRet As String

t = GetSetting(pSection, pKey)
If IsBlank(t) Then
    mRet = ""
Else
    mRet = t
End If

GetSettingString = mRet

End Function

Public Function GetSettingBool(ByVal pSection As String, ByVal pKey As String) As Boolean

Dim t
Dim mRet As Boolean

t = GetSetting(pSection, pKey)
If IsBlank(t) Then
    mRet = False
Else
    mRet = mkBoolean(t)
End If

GetSettingBool = mRet

End Function

Public Function GetSetting(ByVal pSection As String, ByVal pKey As String) As Variant

Dim sr As New swmWinAPIReg
Dim swa As New swmWinAPI

Dim t

t = swa.SwabString(sr.IniRead(gIniFilePath, pSection, pKey))
If t = swmERRORSTRING Then
    t = Null
End If

GetSetting = t

End Function

Public Sub SaveSetting(ByVal pSection As String, ByVal pKey As String, ByVal pValue)

Dim sr As New swmWinAPIReg

If Not sr.IniWrite(gIniFilePath, pSection, pKey, pValue) Then
    Err.Raise 9999, "saveSetting()", "Error " & Err
End If

End Sub

Public Sub SaveSettingBool(ByVal pSection As String, ByVal pKey As String, ByVal pBool)

SaveSetting pSection, pKey, IIf(pBool, "True", "False")

End Sub

Public Function GetFalconInstallPath()

Dim mr As New swmWinAPIReg

GetFalconInstallPath = mr.RegistryGetValueString(HKEY_LOCAL_MACHINE, cFALCON_REG_PATH, cFALCONPATH_REG)

End Function

Private Sub getSettings()

Dim t

gIniFilePath = App.Path & "\" & cINI_FILENAME

t = GetSettingNum(cGRP_STATE, "WindowLeftPos")
If IsBlank(t) Then
    gWindowLeft = 400
Else
    gWindowLeft = t
End If

t = GetSettingNum(cGRP_STATE, "WindowTopPos")
If IsBlank(t) Then
    gWindowTop = 200
Else
    gWindowTop = t
End If

gSlctAllTAC = GetSettingBool(cGRP_STATE, "SelectAllTAC")
gSlctAllCam = GetSettingBool(cGRP_STATE, "SelectAllCam")

End Sub

Public Sub GetInstalls()

Dim i As Integer
Dim mName

For i = 1 To cMAX_INSTALLS
    mName = GetSetting(cGRP_INSTALLS, i)
    If IsBlank(mName) Then
        gInstalls(i) = ""
    Else
        gInstalls(i) = mName
    End If
Next i

End Sub

Public Sub WriteRegFile(ByVal pInstallNum As Integer, Optional ByVal pDeleteFile As Boolean = False)

Dim mRegFile As String
Dim sr As New swmWinAPIReg

mRegFile = GetRegFilename(pInstallNum)

If pDeleteFile Then
    Kill mRegFile
Else
    If Not sr.RegistryWriteKeyToFile(HKEY_LOCAL_MACHINE, cFALCON_REG_PATH, mRegFile) Then
        Err.Raise 9999, "writeRegFile()", "Error " & Err & " writing Falcon registry file"
    End If
    
    If Not sr.RegistryWriteKeyToFile(HKEY_CURRENT_USER, cF4PATCH_REG_PATH, mRegFile, True) Then
        Err.Raise 9999, "writeRegFile()", "Error " & Err & " writing F4Patch registry file"
    End If
End If

End Sub

Public Function GetRegFilename(ByVal pInstallNum) As String

GetRegFilename = App.Path & "\" & pInstallNum & "." & cREG_FILE_EXT

End Function

Public Sub WriteNewInstall(ByVal pInstallNum As Integer, ByVal pInstallPath As String, ByVal pInstallDesc As String, _
                            ByVal pWriteRegFile As Boolean, _
                            Optional ByVal pCl1 As String = "", _
                            Optional ByVal pCl2 As String = "", _
                            Optional ByVal pCl3 As String = "", _
                            Optional ByVal pCl4 As String = "", _
                            Optional ByVal pCl5 As String = "", _
                            Optional ByVal pCl6 As String = "", _
                            Optional ByVal pCl7 As String = "", _
                            Optional ByVal pCl8 As String = "")

Dim mRegFile As String

If IsBlank(pInstallPath) Then
    Err.Raise 9999, "WriteNewInstall()", "Error getting Falcon install path"
End If

SaveSetting cGRP_INSTALLS, pInstallNum, pInstallDesc
SaveSetting cGRP_PATHS, pInstallNum, pInstallPath
SaveSetting cGRP_CL_1, pInstallNum, pCl1
SaveSetting cGRP_CL_2, pInstallNum, pCl2
SaveSetting cGRP_CL_3, pInstallNum, pCl3
SaveSetting cGRP_CL_4, pInstallNum, pCl4
SaveSetting cGRP_CL_5, pInstallNum, pCl5
SaveSetting cGRP_CL_5, pInstallNum, pCl6
SaveSetting cGRP_CL_5, pInstallNum, pCl7
SaveSetting cGRP_CL_5, pInstallNum, pCl8

If pWriteRegFile Then
    WriteRegFile pInstallNum
End If

End Sub

Public Sub DeleteInstall(ByVal pInstallNum As Integer)

SaveSetting cGRP_INSTALLS, pInstallNum, ""
SaveSetting cGRP_PATHS, pInstallNum, ""
SaveSetting cGRP_CL_1, pInstallNum, ""
SaveSetting cGRP_CL_2, pInstallNum, ""
SaveSetting cGRP_CL_3, pInstallNum, ""
SaveSetting cGRP_CL_4, pInstallNum, ""
SaveSetting cGRP_CL_5, pInstallNum, ""
SaveSetting "CustomCommand1", pInstallNum, ""
SaveSetting "CustomCommand2", pInstallNum, ""
SaveSetting "CustomCaption1", pInstallNum, ""
SaveSetting "CustomCaption2", pInstallNum, ""

WriteRegFile pInstallNum, True

End Sub

Public Function GetEmptyInstallSlot() As Integer

Dim i As Integer

For i = 1 To cMAX_INSTALLS
    If IsBlank(GetSetting(cGRP_INSTALLS, i)) Then
        GoTo geis_exit
    End If
Next i
i = 0

geis_exit:
GetEmptyInstallSlot = i
Exit Function

End Function

Public Function GetNameFromInstallNum(ByVal pInstallNum)

Dim mRet

mRet = gInstalls(pInstallNum)

GetNameFromInstallNum = mRet

End Function

Public Function GetInstallNumFromPath(ByVal pPath) As Integer

Dim mRet As Integer
Dim i As Integer
Dim mPath

mRet = 0

For i = 1 To cMAX_INSTALLS
    mPath = GetSetting(cGRP_PATHS, i)
    If NotBlank(mPath) Then
        If mPath = pPath Then
            mRet = i
            Exit For
        End If
    End If
Next i

GetInstallNumFromPath = mRet

End Function

Public Function GetInstallNumFromName(ByVal pName, Optional ByVal pNumIsIncluded As Boolean = False)

Dim i As Integer
Dim mRet

mRet = 0
If pNumIsIncluded Then
    pName = Right(pName, Len(pName) - 3)
End If

For i = 1 To cMAX_INSTALLS
    If gInstalls(i) = pName Then
        mRet = i
    End If
Next i

GetInstallNumFromName = mRet

End Function

Public Function IsValidTacFile(ByVal pFileName) As Boolean

Dim mRet As Boolean
Dim mFileName

mRet = False
mFileName = Trim(UCase(pFileName))

If mFileName = "_NAVAL_TE_TEMPLATE" Then
    GoTo iftf_exit
End If

If mFileName = "AUTO SAVE" Then
    GoTo iftf_exit
End If

If mFileName = "TE_NEW" Then
    GoTo iftf_exit
End If

If mFileName = "Z_DO_NOT_EDIT_NEW" Then
    GoTo iftf_exit
End If

mRet = True

iftf_exit:
IsValidTacFile = mRet

End Function

Public Function CheckValidInstall(ByVal pInstallPath) As Boolean

Dim sp As New swmProcs
Dim mRet As Boolean

If sp.CheckDirPath(pInstallPath & "\terrdata") And sp.CheckDirPath(pInstallPath & "\art") Then
        mRet = True
Else
        mRet = False
End If

CheckValidInstall = mRet

End Function

Public Function CheckInstall(ByVal pInstallPath, ByVal pInstallName) As Boolean

Dim i As Integer
Dim mName, mPath
Dim mInstallOk As Boolean
Dim mInstallPath
Dim mRet As Boolean

mRet = False

For i = 1 To cMAX_INSTALLS
    mName = gInstalls(i)
    If NotBlank(mName) Then
        If NotBlank(pInstallName) Then
            If Trim(pInstallName) = Trim(mName) Then
                mRet = True
            End If
        End If
        
        If NotBlank(pInstallPath) Then
            mPath = GetSetting(cGRP_PATHS, i)
            If NotBlank(mPath) Then
                If Trim(mPath) = Trim(pInstallPath) Then
                    mRet = True
                End If
            End If
        End If
    End If
Next i

CheckInstall = mRet

End Function

Private Function checkCurrentInstall() As Boolean

Dim mRet As Boolean
Dim sr As New swmWinAPIReg
Dim mf As New swmForms
Dim sp As New swmProcs
Dim i As Integer
Dim mName, mPath
Dim mInstallOk As Boolean
Dim mInstallPath

mRet = False
mInstallOk = False

For i = 1 To cMAX_INSTALLS
    mName = gInstalls(i)
    If NotBlank(mName) Then
        mPath = GetSetting(cGRP_PATHS, i)
        If IsBlank(mPath) Then
            Err.Raise 9999, "checkCurrentInstall()", "Install " & i & " has no path"
        Else
            If mPath = gFalconSourcePath Then
                mInstallOk = True
            End If
            If Not sp.CheckDirPath(mPath) Then
                If mf.MsgYN("Install " & gInstalls(i) & ", " & mPath, "is no longer valid.", "Do you wish to remove it from the list") Then
                    DeleteInstall i
                    Msg "Install " & gInstalls(i) & ", " & mPath, " has been removed from the list", "All settings and registry entries have been erased."
                End If
            End If
        End If
    End If
Next i

If Not mInstallOk Then
    If mf.MsgYN(gFalconSourcePath, "is not in the list of installs.", "Do you wish to add it") Then
        LaunchForm.LaunchMode = cLAUNCHMODE_ADD
        Load LaunchForm
        LaunchForm.InstallName = ""
        LaunchForm.Cl1 = ""
        LaunchForm.Cl2 = ""
        LaunchForm.Cl3 = ""
        LaunchForm.Cl4 = ""
        LaunchForm.Cl5 = ""
        LaunchForm.Cl6 = ""
        LaunchForm.Cl7 = ""
        LaunchForm.Cl8 = ""
        LaunchForm.Show vbModal
        If LaunchForm.Result And NotBlank(LaunchForm.InstallName) Then
            mInstallPath = GetFalconInstallPath()
            WriteNewInstall GetEmptyInstallSlot, mInstallPath, LaunchForm.InstallName, True, LaunchForm.Cl1, LaunchForm.Cl2, LaunchForm.Cl3, LaunchForm.Cl4, LaunchForm.Cl5, LaunchForm.Cl6, LaunchForm.Cl7, LaunchForm.Cl8
            GetInstalls
        End If
        Unload LaunchForm
    End If
End If

mRet = True

cci_exit:
checkCurrentInstall = mRet
Exit Function

End Function

Private Sub showInstall()

Dim mHead As String
Dim i As Integer

For i = 1 To cMAX_INSTALLS
    If GetSettingString(cGRP_PATHS, i) = gFalconSourcePath Then
        mHead = cAPP_NAME & "  " & App.Major & "." & App.Minor & "  Rev " & App.Revision
        mHead = mHead & vbNewLine & vbNewLine
        mHead = mHead & "Current Falcon install is" & vbNewLine
        Msg mHead, gInstalls(i), gFalconSourcePath
        Exit Sub
    End If
Next i

Msg "Current Falcon install is not known to Falcon Switcher"

End Sub

Private Sub funnyAbort(ByVal pError, Optional ByVal pFunny As Integer = -1)

Dim mFunny As String

If pFunny = 1 Then
    mFunny = "panic"
ElseIf pFunny = 2 Then
    mFunny = "vomit"
Else
    mFunny = "go catatonic"
End If

Err.Raise 9999, , pError & " - " & cAPP_NAME & " needs to " & mFunny & " now"

End Sub

Private Sub setKeyfile(ByVal pKeyfile As String, ByVal pFalconPath As String)
Dim sp As New swmProcs
Dim swa As New swmWinAPI
Dim mKfPath As String
Dim mDefKfPath As String
Dim mDefBakKfPath As String

mKfPath = pFalconPath & "\" & c_CONFIG_PATH & "\" & pKeyfile
mDefKfPath = pFalconPath & "\" & c_CONFIG_PATH & "\" & c_DEFAULTKEYFILE
mDefBakKfPath = pFalconPath & "\" & c_CONFIG_PATH & "\" & c_DEFAULTBAKKEYFILE

If Not sp.CheckFileExists(mDefBakKfPath) Then
    If Not sp.CheckFileExists(mDefKfPath) Then
        funnyAbort "No default keystrokes.key file found", 1
    End If
    If Not swa.CopyFile(mDefKfPath, mDefBakKfPath) Then
        funnyAbort "Error backing up default keystrokes.key file"
    End If
End If

If IsBlank(pKeyfile) Then
    funnyAbort "Blank keyfile passed to launcher"
End If

If Not swa.CopyFile(mKfPath, mDefKfPath) Then
    funnyAbort "Error copying " & pKeyfile & " file", 2
End If

End Sub

Public Sub LaunchCurrentInstall()

Dim mCommand As String
Dim mParams As String
Dim mResult As Boolean
Dim mInstall As Integer
Dim mFalconPath
Dim mKfName As String

mFalconPath = GetFalconInstallPath()
mInstall = GetInstallNumFromPath(mFalconPath)
If IsBlank(mInstall) Then
    Msg "Current Falcon install is not known to Falcon Switcher"
    Exit Sub
End If
'For i = 1 To cMAX_INSTALLS
'    If GetSettingString(cGRP_PATHS, i) = gFalconSourcePath Then
'        Exit For
'    End If
'Next i
'If i >= cMAX_INSTALLS Then
'    Msg "Current Falcon install is not known to Falcon Switcher"
'    Exit Sub
'End If

If gAuto Then
    If gCommandLine = 1 Then
        mCommand = GetSettingString(cGRP_CL_1, mInstall)
    ElseIf gCommandLine = 2 Then
        mCommand = GetSettingString(cGRP_CL_2, mInstall)
    ElseIf gCommandLine = 3 Then
        mCommand = GetSettingString(cGRP_CL_3, mInstall)
    ElseIf gCommandLine = 4 Then
        mCommand = GetSettingString(cGRP_CL_4, mInstall)
    ElseIf gCommandLine = 5 Then
        mCommand = GetSettingString(cGRP_CL_5, mInstall)
    End If
    
    RunCommandLine mCommand, mFalconPath, False
Else
    LaunchForm.LaunchMode = cLAUNCHMODE_LAUNCH
    LaunchForm.InstallNum = mInstall
    Load LaunchForm
    LaunchForm.InstallName = gInstalls(mInstall)
    LaunchForm.Cl1 = GetSettingString(cGRP_CL_1, mInstall)
    LaunchForm.Cl2 = GetSettingString(cGRP_CL_2, mInstall)
    LaunchForm.Cl3 = GetSettingString(cGRP_CL_3, mInstall)
    LaunchForm.Cl4 = GetSettingString(cGRP_CL_4, mInstall)
    LaunchForm.Cl5 = GetSettingString(cGRP_CL_5, mInstall)
    LaunchForm.Cl6 = GetSettingString(cGRP_CL_6, mInstall)
    LaunchForm.Cl7 = GetSettingString(cGRP_CL_7, mInstall)
    LaunchForm.Cl8 = GetSettingString(cGRP_CL_8, mInstall)
    LaunchForm.ClC = ""
    LaunchForm.Show vbModal
    mResult = LaunchForm.Result
    mCommand = LaunchForm.Command
    mParams = LaunchForm.Param
    mKfName = LaunchForm.KeyfileName
    Unload LaunchForm
    
    If mResult Then
        setKeyfile mKfName, mFalconPath
        If (mKfName <> GetSettingString(cGRP_KEYFILE, mInstall)) Then
            SaveSetting cGRP_KEYFILE, mInstall, mKfName
        End If
'        If (mKfName <> GetSettingString(cGRP_KEYFILE, mInstall)) Then
'            setKeyfile mKfName, mFalconPath
'            SaveSetting cGRP_KEYFILE, mInstall, mKfName
'        End If
        mCommand = mCommand & " " & mParams
        RunCommandLine mCommand, mFalconPath, False
    End If
End If

End Sub

Public Sub RunCommandLine(ByVal pLine, Optional ByVal pFalconPath As String = "", Optional ByVal pWait As Boolean = True)

Dim swa As New swmWinAPI

gCdToPath = Null
gCdToDisk = Null

pLine = insertAllMacros(pLine, pFalconPath)

If gDebug Then
    Msg "Command: " & pLine, "Path: " & gCdToPath, "Disk: " & gCdToDisk
Else
    If NotBlank(gCdToDisk) Then
        ChDrive gCdToDisk
    End If
    If NotBlank(gCdToPath) Then
        ChDir gCdToPath
    End If
    If swa.ExecCmd(pLine, pWait) = -1 Then
        Alert "Error trying to launch ", pLine
    End If
End If

End Sub

Private Function insertAllMacros(ByVal pLine, ByVal pFalconPath As String)

Dim sp As New swmProcs
Dim mRet
Dim mPos As Integer
Dim mLeft As String
Dim mRight As String
Dim mIPaddr As String
Dim mExePos As Integer

If IsBlank(pFalconPath) Then
    pFalconPath = gFalconSourcePath
End If

If Left(pLine, 1) = FULLPATHMACRO Then
    pLine = Right(pLine, Len(pLine) - 1)
Else
    If InStr(1, UCase(pLine), ".EXE") = 0 And InStr(1, UCase(pLine), ".BAT") = 0 Then
        pLine = GetDefaultExe(pFalconPath) & " " & pLine
    End If
    pLine = pFalconPath & "\" & pLine
End If

mExePos = InStr(1, UCase(pLine), ".EXE")
If mExePos = 0 Then
    mExePos = InStr(1, UCase(pLine), ".BAT")
    If mExePos = 0 Then
        Err.Raise 9999, "", "Unable to find a .exe or a .bat file in command line"
    End If
End If
gCdToPath = sp.ExtractPathFromPath(Left(pLine, mExePos + 3))
If Mid(pLine, 2, 2) = ":\" Then
    gCdToDisk = Left(pLine, 1)
End If

mRet = pLine

If NotBlank(pLine) Then
    If InStr(1, UCase(pLine), "$IP") <> 0 Then
        mIPaddr = GetSettingString(cGRP_STATE, "IPAddress")
        If IsBlank(mIPaddr) Then
            Err.Raise 9999, , "$ in command line but no IP address found"
        End If
        pLine = InsertMacro(pLine, "$IP", mIPaddr)
    End If
    
    pLine = InsertMacro(pLine, "$HB", GetSettingString(cGRP_STATE, "HostBandwidth"))
    pLine = InsertMacro(pLine, "$CB", GetSettingString(cGRP_STATE, "ClientBandwidth"))
    
'    pLine = insertMacro(pLine, "$CB", GetSettingString(cGRP_STATE, ""))
    
    pLine = InsertMacro(pLine, "$FP", pFalconPath)

    mRet = pLine
End If

insertAllMacros = mRet

End Function

Public Function InsertMacro(ByVal pLine, ByVal pMacro As String, ByVal pSubst As String)

Dim mRet
Dim mPos As Integer
Dim mLeft As String
Dim mRight As String

mRet = pLine

If NotBlank(pLine) Then
    mPos = InStr(1, UCase(pLine), UCase(pMacro))
    If mPos <> 0 Then
        mLeft = Left(pLine, mPos - 1)
        mRight = Right(pLine, Len(pLine) - (mPos + Len(pMacro) - 1))
        mRet = mLeft & pSubst & mRight
    End If
End If

InsertMacro = mRet

End Function

Private Sub test()

Dim sr As New swmWinAPIReg
Dim mRegFile As String
Dim mS As String


mS = "Pbk: " & gCopyPbk
mS = mS & vbNewLine & "Lbk : " & gCopyLbk
mS = mS & vbNewLine & "All : " & gCopyAll
mS = mS & vbNewLine & "Auto: " & gAuto
mS = mS & vbNewLine & "ClNm: " & gCommandLine
mS = mS & vbNewLine & "Inst: " & gInstall
Msg mS

Exit Sub

mRegFile = GetRegFilename(4)

If Not sr.RegistryDestroyKey(HKEY_LOCAL_MACHINE, cFALCON_REG_PATH) Then
    Err.Raise 9999, "switchFalcon()", "Error deleting old registry key"
End If

If Not sr.RegistryDestroyKey(HKEY_CURRENT_USER, cF4PATCH_REG_PATH) Then
    Err.Raise 9999, "switchFalcon()", "Error deleting old F4Patch registry key"
End If

Msg mRegFile

If Not sr.RegistryReadKeyFromFile(mRegFile) Then
    Err.Raise 9999, "switchFalcon()", "Error reading registry file " & mRegFile
End If

Msg "Test Done"

End Sub

