Attribute VB_Name = "swmExportGlobals"
'Copyright Stephen W McNamee 2003
'Freely re-distributable privided the above copyright is left intact
'
Option Explicit

'swmFunctions
Public Const swmSLASHCHAR = "\"
Public Const swmDRVCHAR = ":"
Public Const swmPARENTDIR = ".."
Public Const swmCURRENTDIR = "."
Public Const swmWILDCARDS = "*.*"
Public Const swmERRORSTRING = "!!ERROR!!"

Public Const swmTWIPSPERCM = 567
Public Const swmTWIPSPERMM = (swmTWIPSPERCM / 10)
Public Const swmTWIPSPERIN = 1440
Public Const swmTWIPSPERPOINT = 20
Public Const swmTWIPSPERPICA = 240
'
'
'swmDb
Public Const swmDBEXT = "MDB"
Public Const swmDBEXTDOT = ".MDB"
Public Const swmDBCOUNTER = 999
'
'
'swmWinAPIReg
Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003
Public Const HKEY_PERFORMANCE_DATA = &H80000004
Public Const HKEY_CURRENT_CONFIG = &H80000005
Public Const HKEY_DYN_DATA = &H80000006
'
'
'swmList
Public Const swmSORTLIST_NONE = 0
Public Const swmSORTLIST_ASCEND = 1
Public Const swmSORTLIST_DESCEND = 2
'
'
'swmWinAPI
Public Const CDERR_DIALOGFAILURE = &HFFFF
Public Const CDERR_FINDRESFAILURE = &H6
Public Const CDERR_GENERALCODES = &H0
Public Const CDERR_INITIALIZATION = &H2
Public Const CDERR_LOADRESFAILURE = &H7
Public Const CDERR_LOADSTRFAILURE = &H5
Public Const CDERR_LOCKRESFAILURE = &H8
Public Const CDERR_MEMALLOCFAILURE = &H9
Public Const CDERR_MEMLOCKFAILURE = &HA
Public Const CDERR_NOHINSTANCE = &H4
Public Const CDERR_NOHOOK = &HB
Public Const CDERR_NOTEMPLATE = &H3
Public Const CDERR_REGISTERMSGFAIL = &HC
Public Const CDERR_STRUCTSIZE = &H1
Public Const FNERR_BUFFERTOOSMALL = &H3003
Public Const FNERR_FILENAMECODES = &H3000
Public Const FNERR_INVALIDFILENAME = &H3002
Public Const FNERR_SUBCLASSFAILURE = &H3001

Public Const OFN_ALLOWMULTISELECT = &H200
Public Const OFN_CREATEPROMPT = &H2000
Public Const OFN_ENABLEHOOK = &H20
Public Const OFN_ENABLETEMPLATE = &H40
Public Const OFN_ENABLETEMPLATEHANDLE = &H80
Public Const OFN_EXPLORER = &H80000
Public Const OFN_EXTENSIONDIFFERENT = &H400
Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_HIDEREADONLY = &H4
Public Const OFN_LONGNAMES = &H200000
Public Const OFN_NOCHANGEDIR = &H8
Public Const OFN_NODEREFERENCELINKS = &H100000
Public Const OFN_NOLONGNAMES = &H40000
Public Const OFN_NONETWORKBUTTON = &H20000
Public Const OFN_NOREADONLYRETURN = &H8000
Public Const OFN_NOTESTFILECREATE = &H10000
Public Const OFN_NOVALIDATE = &H100
Public Const OFN_OVERWRITEPROMPT = &H2
Public Const OFN_PATHMUSTEXIST = &H800
Public Const OFN_READONLY = &H1
Public Const OFN_SHAREAWARE = &H4000
Public Const OFN_SHAREFALLTHROUGH = 2
Public Const OFN_SHARENOWARN = 1
Public Const OFN_SHAREWARN = 0
Public Const OFN_SHOWHELP = &H10

Public Const SW_SHOWDEFAULT = 10
Public Const SW_SHOWMAXIMIZED = 3
Public Const SW_SHOWMINIMIZED = 2
Public Const SW_SHOWMINNOACTIVE = 7
Public Const SW_SHOWNORMAL = 1
Public Const SW_SHOW = 5

Public Const swmTWIPSPERPIXEL_HORIZ = 0
Public Const swmTWIPSPERPIXEL_VERT = 1
'
'

Public Sub ErrMsg(ByVal pFunc As String, ByVal pNum As Long, ByVal pStr As String)

Dim mEmsg

mEmsg = "ERROR " & Str(pNum) & ", " & pFunc & vbNewLine & pStr
MsgBox mEmsg, vbExclamation, "Error Message"

End Sub

Public Sub ErrRaise(Optional ByVal pErrMsg As String = "Unknown Error", Optional ByVal pErrSrc As String = "Unknown Source", Optional ByVal pErrNum As Long = 9999)

Err.Raise pErrNum, pErrSrc, pErrMsg

End Sub

Public Function Tuc(ByVal pVariant As Variant) As Variant

Dim mRet As Variant

mRet = UCase(Trim(pVariant))
If IsBlank(mRet) Then
    mRet = Null
End If

Tuc = mRet

End Function

Public Function Tlc(ByVal pVariant As Variant) As Variant

Dim mRet As Variant

mRet = LCase(Trim(pVariant))
If IsBlank(mRet) Then
    mRet = Null
End If

Tlc = mRet

End Function

Public Function TestFlag(ByVal pFlags As Long, ByVal pFlagToTest As Long) As Boolean

Dim mRet As Boolean

If pFlags = 0 Or pFlagToTest = 0 Then
    mRet = False
Else
    mRet = NotBlank(pFlags And pFlagToTest)
End If

TestFlag = mRet

End Function

Public Function BlankEqual(ByVal pVar1 As Variant, ByVal pVar2 As Variant) As Boolean
'tests to see if two variables are equal
'allowing for one or both to be null

Dim mRet As Boolean

If IsBlank(pVar1) And IsBlank(pVar2) Then
    mRet = True
ElseIf IsBlank(pVar1) And NotBlank(pVar2) Then
    mRet = False
ElseIf NotBlank(pVar1) And IsBlank(pVar2) Then
    mRet = False
Else
    mRet = (pVar1 = pVar2)
End If

BlankEqual = mRet

End Function

Public Function NotBlank(ByVal pVar, Optional ByVal pTrimFirst As Boolean = False) As Boolean

NotBlank = (Not IsBlank(pVar, pTrimFirst))

End Function

Public Function IsBlank(ByVal pVar, Optional ByVal pTrimFirst As Boolean = True) As Boolean

Dim mRet As Boolean, mIsString As Boolean

mRet = True
mIsString = False

On Error GoTo iberr

If IsNull(pVar) Then
    GoTo ibexit
End If

If VarType(pVar) = vbBoolean Then
    If Not (pVar) Then
        GoTo ibexit
    End If
ElseIf VarType(pVar) = vbString Then
    mIsString = True
ElseIf IsNumeric(pVar) Then
    If Len(pVar) <= 1 Then
        If pVar = 0 Then
            GoTo ibexit
        End If
    End If
Else
    mIsString = True
End If

If mIsString Then
    If pTrimFirst Then
        pVar = Trim(pVar)
    End If
    If Len(pVar) = 0 Then
        GoTo ibexit
    End If
End If

mRet = False

ibexit:
On Error GoTo 0
IsBlank = mRet
Exit Function

iberr:
Resume ibexit

End Function

Function Numeric(ByVal pVar) As Double

Dim mRet As Double

If IsNull(pVar) Then
    mRet = 0
ElseIf IsNumeric(pVar) Then
    mRet = Val(pVar)
Else
    mRet = 0
End If

Numeric = mRet

End Function

Public Sub Msg(ByVal pMsg1, Optional ByVal pMsg2 = Null, Optional ByVal pMsg3 = Null)

Dim t As Integer
Dim sf As New swmForms
pMsg1 = IIf(IsNull(pMsg1), "", pMsg1)
pMsg2 = IIf(IsNull(pMsg2), "", pMsg2)
pMsg3 = IIf(IsNull(pMsg3), "", pMsg3)

t = sf.MsgGrunt(pMsg1, pMsg2, pMsg3)

End Sub

Public Sub Alert(ByVal pMsg1, Optional ByVal pMsg2 = Null, Optional ByVal pMsg3 = Null)

Dim sf As New swmForms

pMsg1 = IIf(IsNull(pMsg1), "", pMsg1)
pMsg2 = IIf(IsNull(pMsg2), "", pMsg2)
pMsg3 = IIf(IsNull(pMsg3), "", pMsg3)

Call sf.MsgGrunt(pMsg1, pMsg2, pMsg3, , 2)

End Sub

Public Function mkBoolean(ByVal pVar) As Boolean

Dim mRet As Boolean
Dim mVt

mVt = VarType(pVar)
'vbEmpty        0       Empty (uninitialized)
'vbNull         1       Null (no valid data)
'vbInteger      2       Integer
'vbLong         3       Long integer
'vbSingle       4       Single-precision floating-point number
'vbDouble       5       Double-precision floating-point number
'vbCurrency     6       Currency value
'vbDate         7       Date value
'vbString       8       String
'vbObject       9       Object
'vbError        10      Error value
'vbBoolean      11      Boolean value
'vbVariant      12      Variant (used only with arrays of variants)
'vbDataObject   13      A data access object
'vbDecimal      14      Decimal value
'vbByte         17      Byte value
'vbArray        8192    Array

If mVt = vbBoolean Then
    mRet = pVar
ElseIf mVt = vbString Then
    If Trim(UCase(pVar)) = "TRUE" Then
        mRet = True
    ElseIf Trim(UCase(pVar)) = "FALSE" Then
        mRet = False
    Else
        mRet = (NotBlank(pVar) And Val(pVar) <> 0)
    End If
ElseIf IsNumeric(pVar) Then
    mRet = (pVar <> 0)
Else
    mRet = False
End If

mkBoolean = mRet

End Function

Public Sub ThrowError(Optional ByVal pSource As String = "Global", Optional ByVal pDesc As String = "An exception has occured - please contact the help desk")

Err.Raise 999, pSource, pDesc

End Sub

Public Sub SetAppName(ByVal pAppName)

Dim mm As New swmForms

mm.SetAppName pAppName

End Sub

Public Function LimitString(ByVal pString, ByVal pMaxChars, ByVal pAscii)

If Len(pString) < pMaxChars Then
    LimitString = pAscii
Else
    LimitString = 0
End If

End Function
